src/Entity/Site.php
<?php

namespace App\Entity;

use App\Repository\SiteRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=SiteRepository::class)
 */
class Site
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $Name;

    /**
     * @ORM\Column(type="boolean", nullable=true)
     */
    private $authorized_store_delivery;

    /**
     * @ORM\Column(type="boolean", nullable=true)
     */
    private $autorized_delivery;

    /**
     * @ORM\Column(type="float", nullable=true)
     */
    private $franco;

    /**
     * @ORM\Column(type="float", nullable=true)
     */
    private $mini_delivery_price;

    /**
     * @ORM\Column(type="float", nullable=true)
     */
    private $kilometers_price;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $order_email;

    /**
     * @ORM\OneToOne(targetEntity=SiteAdress::class, mappedBy="site", cascade={"persist", "remove"})
     * @Assert\Type(type="App\Entity\SiteAdress")
     * @Assert\Valid
     */
    private $siteAdress;

    /**
     * @ORM\OneToMany(targetEntity=SiteContact::class, mappedBy="site_id", cascade={"persist"})
     */
    private $siteContacts;

    /**
     * @ORM\OneToOne(targetEntity=SiteHoraire::class, mappedBy="siteId", cascade={"persist", "remove"})
     * @Assert\Type(type="App\Entity\SiteHoraire")
     * @Assert\Valid
     */
    private $siteHoraires;

    /**
     * @ORM\OneToOne(targetEntity=SiteText::class, mappedBy="siteId", cascade={"persist", "remove"})
     * @ORM\JoinColumn(nullable=true)
     */
    private $siteText;

    /**
     * @ORM\OneToOne(targetEntity=SiteImage::class, mappedBy="siteId", cascade={"persist", "remove"})
     */
    private $siteImage;

    /**
     * @ORM\OneToMany(targetEntity=SiteActus::class, mappedBy="siteId")
     */
    private $siteActuses;

    public function __construct()
    {
        $this->siteContacts = new ArrayCollection();
        $this->siteAdress = new SiteAdress;
        $this->siteActuses = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getName(): ?string
    {
        return $this->Name;
    }

    public function setName(string $Name): self
    {
        $this->Name = $Name;

        return $this;
    }

    public function getAuthorizedStoreDelivery(): ?bool
    {
        return $this->authorized_store_delivery;
    }

    public function setAuthorizedStoreDelivery(?bool $authorized_store_delivery): self
    {
        $this->authorized_store_delivery = $authorized_store_delivery;

        return $this;
    }

    public function getAutorizedDelivery(): ?bool
    {
        return $this->autorized_delivery;
    }

    public function setAutorizedDelivery(?bool $autorized_delivery): self
    {
        $this->autorized_delivery = $autorized_delivery;

        return $this;
    }

    public function getFranco(): ?float
    {
        return $this->franco;
    }

    public function setFranco(?float $franco): self
    {
        $this->franco = $franco;

        return $this;
    }

    public function getMiniDeliveryPrice(): ?float
    {
        return $this->mini_delivery_price;
    }

    public function setMiniDeliveryPrice(?float $mini_delivery_price): self
    {
        $this->mini_delivery_price = $mini_delivery_price;

        return $this;
    }

    public function getKilometersPrice(): ?float
    {
        return $this->kilometers_price;
    }

    public function setKilometersPrice(?float $kilometers_price): self
    {
        $this->kilometers_price = $kilometers_price;

        return $this;
    }

    public function getOrderEmail(): ?string
    {
        return $this->order_email;
    }

    public function setOrderEmail(string $order_email): self
    {
        $this->order_email = $order_email;

        return $this;
    }

    /**
     * @return Collection|SiteAddress[]
     */

    public function getSiteAdress(): ?SiteAdress
    {
        return $this->siteAdress;
    }

    public function setSiteAdress(?SiteAdress $siteAdress): self
    {
        // unset the owning side of the relation if necessary
        if ($siteAdress === null && $this->siteAdress !== null) {
            $this->siteAdress->setSite(null);
        }

        // set the owning side of the relation if necessary
        if ($siteAdress !== null && $siteAdress->getSite() !== $this) {
            $siteAdress->setSite($this);
        }

        $this->siteAdress = $siteAdress;

        return $this;
    }

    /**
     * @return Collection|SiteContact[]
     */
    public function getSiteContacts(): Collection
    {
        return $this->siteContacts;
    }

    public function addSiteContact(SiteContact $siteContact): self
    {
        if (!$this->siteContacts->contains($siteContact)) {
            $this->siteContacts[] = $siteContact;
            $siteContact->setSiteId($this);
        }

        return $this;
    }

    public function removeSiteContact(SiteContact $siteContact): self
    {
        if ($this->siteContacts->removeElement($siteContact)) {
            // set the owning side to null (unless already changed)
            if ($siteContact->getSiteId() === $this) {
                $siteContact->setSiteId(null);
            }
        }

        return $this;
    }

    public function getSiteHoraires(): ?SiteHoraire
    {
        return $this->siteHoraires;
    }

    public function setSiteHoraires(?SiteHoraire $siteHoraires): self
    {
        // unset the owning side of the relation if necessary
        if ($siteHoraires === null && $this->siteHoraires !== null) {
            $this->siteHoraires->setSiteId(null);
        }

        // set the owning side of the relation if necessary
        if ($siteHoraires !== null && $siteHoraires->getSiteId() !== $this) {
            $siteHoraires->setSiteId($this);
        }

        $this->siteHoraires = $siteHoraires;

        return $this;

    }

    public function getSiteText(): ?SiteText
    {
        return $this->siteText;
    }

    public function setSiteText(SiteText $siteText): self
    {
        // set the owning side of the relation if necessary
        if ($siteText->getSiteId() !== $this) {
            $siteText->setSiteId($this);
        }

        $this->siteText = $siteText;

        return $this;
    }

    public function getSiteImage(): ?SiteImage
    {
        return $this->siteImage;
    }

    public function setSiteImage(SiteImage $siteImage): self
    {
        // set the owning side of the relation if necessary
        if ($siteImage->getSiteId() !== $this) {
            $siteImage->setSiteId($this);
        }

        $this->siteImage = $siteImage;

        return $this;
    }
    public function __toString()
    {
        return $this->Name;
    }

    /**
     * @return Collection|SiteActus[]
     */
    public function getSiteActuses(): Collection
    {
        return $this->siteActuses;
    }

    public function addSiteActus(SiteActus $siteActus): self
    {
        if (!$this->siteActuses->contains($siteActus)) {
            $this->siteActuses[] = $siteActus;
            $siteActus->setSiteId($this);
        }

        return $this;
    }

    public function removeSiteActus(SiteActus $siteActus): self
    {
        if ($this->siteActuses->removeElement($siteActus)) {
            // set the owning side to null (unless already changed)
            if ($siteActus->getSiteId() === $this) {
                $siteActus->setSiteId(null);
            }
        }

        return $this;
    }
}

src/Form/SiteType.php
<?php

namespace App\Form;

use App\Entity\Site;
use App\Entity\SiteAdress;
use App\Form\SiteAdressType;
use App\Form\SiteContactType;
use App\Form\SiteHoraireType;
use Doctrine\DBAL\Types\BooleanType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormTypeInterface;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\Extension\Core\Type\NumberType;

class SiteType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('Name', TextType::class, [
                'label' => 'Nom du site',
            ])
            ->add('authorized_store_delivery',CheckboxType::class, [
                'label' => 'Autorise la livraison en magasin'
            ])
            ->add('autorized_delivery', CheckboxType::class, [
                'label' => 'Autorise la livraison'
            ])
            ->add('franco', NumberType::class, [
                'label' => 'Franco alloué',
                'scale' => 2
            ])
            ->add('mini_delivery_price', NumberType::class, [
                'label' => 'Tarifs minimum de livraison',
                'scale' => 2,
            ])
            ->add('kilometers_price', NumberType::class, [
                'label' => 'prix au Kilomètre',
                'scale' => 2,
            ])
            ->add('order_email', TextType::class, [
                'label' => 'email de commande'
            ])
            ->add('siteAdress', SiteAdressType::class, [
                'label' => 'adresse du site',
                'by_reference' => false,
            ])
            ->add('siteContacts', CollectionType::class, [
                'allow_add' => true,
                'by_reference' => false,
                'entry_type' => SiteContactType::class,
            ])
            ->add('siteHoraires', SiteHoraireType::class, [
                'by_reference' => false,
            ])
            
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Site::class,
        ]);
    }
}

src/Controller/SiteController.php
<?php

namespace App\Controller;

use App\Entity\Site;
use App\Form\SiteType;
use App\Repository\SiteRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Filesystem\Filesystem;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/site")
 */
class SiteController extends AbstractController
{
    /**
     * @Route("/", name="site_index", methods={"GET"})
     */
    public function index(SiteRepository $siteRepository): Response
    {
        return $this->render('site/index.html.twig', [
            'sites' => $siteRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="site_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $site = new Site();
        $form = $this->createForm(SiteType::class, $site);
        $form->handleRequest($request);
        
        if ($form->isSubmitted() && $form->isValid()) {

            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($site);
            $entityManager->flush();

            $directory = 'public/site/';
            $id = $site->getId();
            $directory .= $id;
            $filesysteme = new Filesystem();
            try {
                $filesysteme->mkdir($directory);
            } catch (IOExceptionInterface $exception) {
                echo "An error occurred while creating your directory at ".$exception->getPath();
            }
            $filename = 'contactphoto.png';

            /** @var ArrayCollection $file */
            $siteContacts = $form['siteContacts']->getData();
            $siteContact = $siteContacts->getValues()[0];
            $file = $siteContact->getPhotoFile();
            $file->move($directory, $filename);
            $siteContact->setPhoto($filename);
            $entityManager->flush();

            return $this->redirectToRoute('site_index');
        }

        return $this->render('site/new.html.twig', [
            'site' => $site,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="site_show", methods={"GET"})
     */
    public function show(Site $site): Response
    {
        return $this->render('site/show.html.twig', [
            'site' => $site,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="site_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Site $site): Response
    {
        $form = $this->createForm(SiteType::class, $site);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('site_index');
        }

        return $this->render('site/edit.html.twig', [
            'site' => $site,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="site_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Site $site): Response
    {
        if ($this->isCsrfTokenValid('delete'.$site->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($site);
            $entityManager->flush();
        }

        return $this->redirectToRoute('site_index');
    }
}

templates/site/_delete_form.html.twig
<form method="post" action="{{ path('site_delete', {'id': site.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ site.id) }}">
    <button class="btn">Delete</button>
</form>

templates/site/_form.html.twig
{{ form_start(form) }}
    {{ form_row(form.Name) }}
    {{ form_row(form.authorized_store_delivery) }}
    {{ form_row(form.autorized_delivery) }}
    {{ form_row(form.franco) }}
    {{ form_row(form.mini_delivery_price) }}
    {{ form_row(form.kilometers_price) }}
    {{ form_row(form.order_email) }}
    <div>
    <h2>Information Adresse du magasin</h2>
    {{ form_row (form.siteAdress.street) }}
    {{ form_row(form.siteAdress.zipcode) }}
    {{ form_row(form.siteAdress.city) }}
    {{ form_row(form.siteAdress.country) }}
    {{ form_row(form.siteAdress.latitude) }}
    {{ form_row(form.siteAdress.longitude) }}

    </div>
    <div>
    <h3>Contact du site</h3>
    {{ form_widget(form.siteContacts.vars.prototype) }}
    </div>
    <div>
    <h4>Horaires du site</h4>
    {{ form_row(form.siteHoraires.day) }}
    {{ form_row(form.siteHoraires.AM_timetable) }}
    {{ form_row(form.siteHoraires.pm_timetable) }}
    {{ form_row(form.siteHoraires.is_ferie) }}
    </div>
    <button class="btn btn-primary">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/site/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Site{% endblock %}

{% block body %}
    <h1>Edit Site</h1>

    {{ include('site/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('site_index') }}">back to list</a>

    {{ include('site/_delete_form.html.twig') }}
{% endblock %}

templates/site/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Site index{% endblock %}

{% block body %}
    <h1>Site index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Name</th>
                <th>Authorized_store_delivery</th>
                <th>Autorized_delivery</th>
                <th>Franco</th>
                <th>Mini_delivery_price</th>
                <th>Kilometers_price</th>
                <th>Order_email</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for site in sites %}
            <tr>
                <td>{{ site.id }}</td>
                <td>{{ site.Name }}</td>
                <td>{{ site.authorizedStoreDelivery ? 'Yes' : 'No' }}</td>
                <td>{{ site.autorizedDelivery ? 'Yes' : 'No' }}</td>
                <td>{{ site.franco }}</td>
                <td>{{ site.miniDeliveryPrice }}</td>
                <td>{{ site.kilometersPrice }}</td>
                <td>{{ site.orderEmail }}</td>
                <td>
                    <a href="{{ path('site_show', {'id': site.id}) }}">show</a>
                    <a href="{{ path('site_edit', {'id': site.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="9">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('site_new') }}">Create new</a>
{% endblock %}

templates/site/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Site{% endblock %}

{% block body %}
    <h1>Creer nouveau site</h1>

    {{ include('site/_form.html.twig') }}

    <a href="{{ path('site_index') }}">back to list</a>
{% endblock %}

templates/site/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Site{% endblock %}

{% block body %}
    <h1>Site</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ site.id }}</td>
            </tr>
            <tr>
                <th>Name</th>
                <td>{{ site.Name }}</td>
            </tr>
            <tr>
                <th>Authorized_store_delivery</th>
                <td>{{ site.authorizedStoreDelivery ? 'Yes' : 'No' }}</td>
            </tr>
            <tr>
                <th>Autorized_delivery</th>
                <td>{{ site.autorizedDelivery ? 'Yes' : 'No' }}</td>
            </tr>
            <tr>
                <th>Franco</th>
                <td>{{ site.franco }}</td>
            </tr>
            <tr>
                <th>Mini_delivery_price</th>
                <td>{{ site.miniDeliveryPrice }}</td>
            </tr>
            <tr>
                <th>Kilometers_price</th>
                <td>{{ site.kilometersPrice }}</td>
            </tr>
            <tr>
                <th>Order_email</th>
                <td>{{ site.orderEmail }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('site_index') }}">back to list</a>

    <a href="{{ path('site_edit', {'id': site.id}) }}">edit</a>

    {{ include('site/_delete_form.html.twig') }}
{% endblock %}